<template>
  <div class="chat-list">
    <!-- Start of Navigation -->
    <!-- Start of Sidebar -->
    <div class="sidebar" id="sidebar">
      <div class="container">
        <div class="col-md-12">
          <div class="row">
            <div class="col-md-2 pointer">
                <i class="material-icons" @click="closeChatSidebar">close</i>
            </div>
            <div class="col-md-10">

                <p>Search Message</p>
            </div>
            <div class="col-md-12">
              <div class="search">
                <form class="form-inline position-relative" @submit.prevent>
                  <input
                    type="search"
                    class="form-control capsule bg-white"
                    id="conversations"
                    placeholder="Search..."
                    v-model="searchMessageList"
                    style="width:100%"
                  >
                  <button type="button" class="btn btn-link loop">
                    <i class="material-icons">search</i>
                  </button>
                </form>
              </div>
            </div>

           
          </div>

        </div>

        <div class="col-md-12 px-0 bg-white" >
          <!-- Start of Discussions -->
          <div id="discussions" class="tab-pane fade in active show">
            <div class="discussions">
              <div class="list-group pt-1">
                <template v-for="message in sortedMessageList">
                  <span
                    class="filterDiscussions all unread single py-2 pl-3"
                    :class="{'bg-active':isSelected(message.id)}"
                    style="cursor:pointer1"
                    :key="message.id"
                     v-scroll-to="setOption(message.id)"
                  >

                
                    <div class="data p-1" style="word-break:break-all">
                        <text-highlight class="d-block float-left text-muted" :queries="searchMessageList">{{message.text}}</text-highlight>
                      <!-- <span class="d-block float-left text-muted">{{message.text}}</span> -->
                    <small class="float-right text-muted align-self-center">{{parseDate(message.created_at)}}</small>

                    </div>
                
                  </span>
                </template>
              </div>
            </div>
          </div>
          <!-- End of Discussions -->
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import chatMixin from "@/mixins/ChatMixin";
import moment from 'moment';
import EventBus from "@/EventBus.js";
import TextHighlight from 'vue-text-highlight';

export default {
  mixins: [chatMixin],
  components:{TextHighlight},
  computed: {
    sortedMessageList() {
      let sorted = _.sortBy(this.messageList, [
        function(o) {
          return o.created_at;
        }
      ]).reverse();
      return sorted;
    },
    selectedRoomMessages() {
      return this.$store.getters["chat/selectedRoom"].messages;
    }
  },
  data() {
    return {
      searchMessageList: "",
      messageList: null,
      scrollOpt:{
        container: '#content',
        duration: 300,
        easing: 'linear',
        offset: -200,
        force: true,
        cancelable: true,
        onStart: false,
        onDone: false,
        onCancel: false,
        x: false,
        y: true
 
      }
    };
  },
  watch: {
     searchMessageList() {
      this.messageList = []
      
      if (this.searchMessageList.length > 0) {
        for (const message of this.selectedRoomMessages) {
            for (const singleContent of message.content) {
                if (singleContent.type =='text') {
                    if (singleContent.text.toLowerCase().includes(this.searchMessageList)) {
                        this.messageList.push({
                            id:message.id,
                            text:singleContent.text,
                            created_at:message.created_at
                        })
                    }
                }
            }
        }
        // this.messageList = _.find(stateMessageList, (message) =>{
        //     return  _.find(message.content, (singleContent)=> {
        //         singleContent.toLowerCase().includes(this.searchMessageList); 
        //     })
        //     });
      } else {
        this.messageList = [];
      }
    }
  },
  methods: {
      setOption(id){
          return {el:'#message'+id,...this.scrollOpt}
      },

    closeChatSidebar(){
        EventBus.$emit("closeChatSidebar");

    },
    parseDate(date){
        return moment(date,"YYYY-MM-DD kk:mm:ss").fromNow()
    },
    isSelected(roomId) {
      if (!this.selectedRoom) {
        return false;
      }
      return this.selectedRoom.id == roomId;
    },
  

  },
   mounted() {
     
  EventBus.$on("closeChatSidebar", value => {
        this.searchMessageList=''
        this.messageList = []
    });
  }
};
</script>
<style lang="scss" scoped>
.chat-list {
  z-index: 1;
}
.sidebar {
  background: #f5f5f5;
  height: 100%;
  padding-top: 20px !important;
  .container {
    padding-left: 5px;
    padding-right: 0px;
  }
  .search {
    margin-bottom: 0;
    input {
      height: 5vh;
      font-size: 0.8rem;
    }
    margin-bottom: 5px;

    //   font-size: inherit
  }
  .sort {
    margin-bottom: 10px;
  }
  width: 300px
}
#discussions {
  max-height: 70vh;
  overflow-y: scroll;
  &::-webkit-scrollbar {
    display: none;
  }
}
.sidebar .discussions .single {
  &:hover {
    background: #fdfdfd !important;
  }

  & {
    border-bottom: 0.2px solid #dee2e6 !important;
    position: relative;
    cursor: pointer;
  }
  &:first-child {
    border-top: 0.2px solid #dee2e6 !important;
  }
}

.avatar-md {
  box-shadow: none;
}

.channel-image {
  position: absolute;
  width: 25px !important;
  left: 10px;
  bottom: 10px;
}
.bg-active{
    background: #fdfdfd
}
</style>